Type: Package
Package: msigdbr
Title: MSigDB Gene Sets for Multiple Organisms in a Tidy Data Format
Version: 26.1.0
Authors@R: 
    person("Igor", "Dolgalev", , "igor.dolgalev@nyumc.org", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-4451-126X"))
Description: Provides the 'Molecular Signatures Database' (MSigDB) gene
    sets typically used with the 'Gene Set Enrichment Analysis' (GSEA)
    software (Subramanian et al. 2005 <doi:10.1073/pnas.0506580102>,
    Liberzon et al. 2015 <doi:10.1016/j.cels.2015.12.004>, Castanza et al.
    2023 <doi:10.1038/s41592-023-02014-7>) as an R data frame. The package
    includes the human genes as listed in MSigDB as well as the
    corresponding symbols and IDs for frequently studied model organisms
    such as mouse, rat, pig, fly, and yeast.
License: MIT + file LICENSE
URL: https://igordot.github.io/msigdbr/
BugReports: https://github.com/igordot/msigdbr/issues
Depends: R (>= 4.1)
Imports: assertthat, babelgene (>= 22.9), curl, dplyr (>= 1.1.1),
        lifecycle, methods, rlang, tibble, tidyselect (>= 1.2.0), tools
Suggests: knitr, rmarkdown, roxygen2, testthat
Config/Needs/website: rmarkdown
Encoding: UTF-8
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-03-12 03:54:54 UTC; id460
Author: Igor Dolgalev [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4451-126X>)
Maintainer: Igor Dolgalev <igor.dolgalev@nyumc.org>
Repository: CRAN
Date/Publication: 2026-03-12 07:00:02 UTC
Built: R 4.6.0; ; 2026-04-26 16:14:54 UTC; unix

Type: Package
Package: msigdbr
Title: MSigDB Gene Sets for Multiple Organisms in a Tidy Data Format
Version: 25.1.1
Authors@R: 
    person("Igor", "Dolgalev", , "igor.dolgalev@nyumc.org", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-4451-126X"))
Description: Provides the 'Molecular Signatures Database' (MSigDB) gene
    sets typically used with the 'Gene Set Enrichment Analysis' (GSEA)
    software (Subramanian et al. 2005 <doi:10.1073/pnas.0506580102>,
    Liberzon et al. 2015 <doi:10.1016/j.cels.2015.12.004>, Castanza et al.
    2023 <doi:10.1038/s41592-023-02014-7>) as an R data frame. The package
    includes the human genes as listed in MSigDB as well as the
    corresponding symbols and IDs for frequently studied model organisms
    such as mouse, rat, pig, fly, and yeast.
License: MIT + file LICENSE
URL: https://igordot.github.io/msigdbr/
BugReports: https://github.com/igordot/msigdbr/issues
Depends: R (>= 4.1)
Imports: assertthat, babelgene (>= 22.9), curl, dplyr (>= 1.1.1),
        lifecycle, methods, rlang, tibble, tidyselect (>= 1.2.0), tools
Suggests: knitr, rmarkdown, roxygen2, testthat
Config/Needs/website: rmarkdown
Encoding: UTF-8
RoxygenNote: 7.3.2
NeedsCompilation: no
Packaged: 2025-07-21 16:44:43 UTC; id460
Author: Igor Dolgalev [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4451-126X>)
Maintainer: Igor Dolgalev <igor.dolgalev@nyumc.org>
Repository: CRAN
Date/Publication: 2025-07-21 23:00:02 UTC

# msigdbr: MSigDB data frame

[![CRAN](https://www.r-pkg.org/badges/version/msigdbr)](https://cran.r-project.org/package=msigdbr)
[![CRAN downloads](https://cranlogs.r-pkg.org/badges/last-month/msigdbr)](https://cran.r-project.org/package=msigdbr)
[![R-CMD-check](https://github.com/igordot/msigdbr/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/igordot/msigdbr/actions/workflows/R-CMD-check.yaml)
[![Codecov test coverage](https://codecov.io/gh/igordot/msigdbr/graph/badge.svg)](https://app.codecov.io/gh/igordot/msigdbr)

The msigdbr R package provides Molecular Signatures Database (MSigDB) gene sets:

* in an R-friendly tidy format with one gene pair per row
* for multiple frequently studied model organisms in addition to the original human genes
* as gene symbols as well as NCBI Entrez and Ensembl IDs
* without accessing external resources requiring an active internet connection

Check the [documentation website](https://igordot.github.io/msigdbr/) for more information.

#' List the species available in the msigdbr package
#'
#' @return A data frame of the available species.
#'
#' @importFrom babelgene species
#' @importFrom dplyr arrange distinct select
#'
#' @export
#'
#' @examples
#' msigdbr_species()
msigdbr_species <- function() {
  babelgene::species() |>
    tibble::as_tibble() |>
    dplyr::select(
      species_name = "scientific_name",
      species_common_name = "common_name"
    ) |>
    rbind(c("Homo sapiens", "human")) |>
    dplyr::distinct() |>
    dplyr::arrange(.data$species_name)
}

test_that("msigdbr_species()", {
  species <- msigdbr_species()
  expect_s3_class(species, "tbl_df")
  expect_equal(nrow(species), 20)
  expect_identical(colnames(species), c("species_name", "species_common_name"))
  expect_match(species$species_name, "Homo sapiens", fixed = TRUE, all = FALSE)
  expect_match(species$species_name, "Mus musculus", fixed = TRUE, all = FALSE)
  expect_match(species$species_name, "Drosophila melanogaster", fixed = TRUE, all = FALSE)
})

#' Retrieve the gene sets data frame
#'
#' Retrieve a data frame of gene sets and their member genes.
#' The original human genes can be converted into their corresponding counterparts in various model organisms, including mouse, rat, pig, zebrafish, fly, and yeast.
#' The output includes gene symbols along with NCBI and Ensembl IDs.
#'
#' Historically, the MSigDB resource has been tailored to the analysis of human-specific datasets, with gene sets exclusively aligned to the human genome.
#' Starting with release 2022.1, MSigDB incorporated a database of mouse-native gene sets and was split into human and mouse divisions ("Hs" and "Mm").
#' Each one is provided in the approved gene symbols of its respective species.
#'
#' Mouse MSigDB includes gene sets curated from mouse-centric datasets and specified in native mouse gene identifiers, eliminating the need for ortholog mapping.
#'
#' @param db_species Species abbreviation for the human or mouse databases (`"HS"` or `"MM"`).
#' @param species Species name for output genes, such as `"Homo sapiens"` or `"Mus musculus"`. Both scientific and common names are acceptable. Use `msigdbr_species()` to see the available options.
#' @param collection Collection abbreviation, such as `"H"` or `"C1"`. Use `msigdbr_collections()` to see the available options.
#' @param subcollection Sub-collection abbreviation, such as `"CGP"` or `"BP"`. Use `msigdbr_collections()` for the available options.
#' @param category `r lifecycle::badge("deprecated")` use the `collection` argument
#' @param subcategory `r lifecycle::badge("deprecated")` use the `subcollection` argument
#'
#' @return A tibble (a data frame with class [`tibble::tbl_df`]) of gene sets with one gene per row.
#'
#' @references <https://www.gsea-msigdb.org/gsea/msigdb/index.jsp>
#'
#' @importFrom babelgene orthologs
#' @importFrom dplyr arrange distinct filter inner_join mutate rename select
#'
#' @export
#'
#' @examplesIf (identical(Sys.getenv("NOT_CRAN"), "true") || identical(Sys.getenv("IN_PKGDOWN"), "true"))
#' # Get all human gene sets
#' gs <- msigdbr()
#' head(gs)
#'
#' # Get all mouse gene sets
#' gs <- msigdbr(db_species = "MM", species = "Mus musculus")
#' head(gs)
#'
#' # Get CGP (chemical and genetic perturbations) gene sets with genes mapped to rat orthologs
#' gs <- msigdbr(species = "Rattus norvegicus", collection = "C2", subcollection = "CGP")
#' head(gs)
msigdbr <- function(db_species = "HS", species = "human", collection = NULL, subcollection = NULL, category = deprecated(), subcategory = deprecated()) {
  # Check parameters
  assertthat::assert_that(
    is.character(db_species),
    length(db_species) == 1,
    nchar(db_species) == 2
  )
  db_species <- toupper(db_species)
  assertthat::assert_that(
    is.character(species),
    length(species) == 1,
    nchar(species) > 1
  )
  if (!is.null(collection)) {
    assertthat::assert_that(
      is.character(collection),
      length(collection) == 1,
      nchar(collection) > 0
    )
  }
  if (!is.null(subcollection)) {
    assertthat::assert_that(
      is.character(subcollection),
      length(subcollection) == 1,
      nchar(subcollection) > 0
    )
  }

  # Define name variants for species with caveats
  species_hs <- c("Homo sapiens", "human")
  species_mm <- c("Mus musculus", "mouse", "house mouse")

  # Use only mouse genes for mouse database
  if (db_species == "MM" && !(species %in% species_mm)) {
    stop("Use `species = \"mouse\"` when selecting the mouse database.")
  }

  # Display a message when selecting the human database and mouse genes
  if (db_species == "HS" && species %in% species_mm) {
    mm_msg <- "Using human MSigDB with ortholog mapping to mouse. Use `db_species = \"MM\"` for mouse-native gene sets."
    rlang::inform(message = mm_msg, .frequency = "once", .frequency_id = "msigdbr_species_mm")
  }

  # Check for deprecated category arguments
  if (lifecycle::is_present(category) && !is.null(category)) {
    lifecycle::deprecate_warn("10.0.0", "msigdbr(category)", "msigdbr(collection)")
    assertthat::assert_that(is.character(category), length(category) == 1, nchar(category) > 0)
    collection <- category
  }
  if (lifecycle::is_present(subcategory) && !is.null(subcategory)) {
    lifecycle::deprecate_warn("10.0.0", "msigdbr(subcategory)", "msigdbr(subcollection)")
    assertthat::assert_that(is.character(subcategory), length(subcategory) == 1, nchar(subcategory) > 0)
    subcollection <- subcategory
  }

  # Get the gene sets table
  mdb <- load_msigdb_df(target_species = db_species)
  mdb <- tibble::as_tibble(mdb)

  # Filter by collection
  if (is.character(collection)) {
    if (collection %in% mdb$gs_collection) {
      mdb <- dplyr::filter(mdb, .data$gs_collection == collection)
    } else {
      stop("Unknown collection. Use `msigdbr_collections()` to see the available collections.")
    }
  }

  # Filter by sub-collection
  if (is.character(subcollection)) {
    if (subcollection %in% mdb$gs_subcollection) {
      mdb <- dplyr::filter(mdb, .data$gs_subcollection == subcollection)
    } else if (subcollection %in% gsub(".*:", "", mdb$gs_subcollection)) {
      mdb <- dplyr::filter(mdb, gsub(".*:", "", .data$gs_subcollection) == subcollection)
    } else {
      stop("Unknown subcollection.")
    }
  }

  # Create a fake orthologs table for cases when orthologs are not needed
  species_genes <- dplyr::select(
    mdb,
    gene_symbol = "db_gene_symbol",
    ncbi_gene = "db_ncbi_gene",
    ensembl_gene = "db_ensembl_gene"
  )
  species_genes <- dplyr::mutate(
    species_genes,
    db_ensembl_gene = .data$ensembl_gene
  )

  # Retrieve orthologs for the non-human species for the human database
  if (db_species == "HS" && !(species %in% species_hs)) {
    species_genes <- babelgene::orthologs(
      genes = unique(mdb$db_ensembl_gene),
      species = species
    )
    species_genes <- dplyr::select(
      species_genes,
      db_ensembl_gene = "human_ensembl",
      gene_symbol = "symbol",
      ncbi_gene = "entrez",
      ensembl_gene = "ensembl",
      ortholog_taxon_id = "taxon_id",
      ortholog_sources = "support",
      num_ortholog_sources = "support_n",
      !tidyselect::any_of(c("human_symbol", "human_entrez"))
    )
    species_genes$ncbi_gene <- as.character(species_genes$ncbi_gene)
  }

  # Remove duplicate entries
  species_genes <- dplyr::distinct(species_genes)

  # Combine gene sets and orthologs
  mdb <- dplyr::inner_join(
    mdb,
    species_genes,
    by = "db_ensembl_gene",
    relationship = "many-to-many"
  )

  # Reorder columns for better readability
  mdb <- dplyr::select(
    mdb,
    "gene_symbol",
    "ncbi_gene",
    "ensembl_gene",
    "db_gene_symbol",
    "db_ncbi_gene",
    "db_ensembl_gene",
    "source_gene",
    "gs_id",
    "gs_name",
    "gs_collection",
    "gs_subcollection",
    everything()
  )
  mdb <- dplyr::arrange(mdb, .data$gs_name, .data$db_gene_symbol, .data$gene_symbol)

  # Add columns from the old msigdbr output if old arguments are present
  if (lifecycle::is_present(category) || lifecycle::is_present(subcategory)) {
    mdb <- dplyr::mutate(
      mdb,
      entrez_gene = .data$ncbi_gene,
      gs_cat = .data$gs_collection,
      gs_subcat = .data$gs_subcollection,
    )
  }

  return(mdb)
}

# Skip on CRAN due to long run-time and use of web resources
skip_on_cran()

library(dplyr)

test_that("species", {
  # Human database and human genes
  m_hs_hs <- msigdbr()
  expect_identical(m_hs_hs, msigdbr(species = "Homo sapiens"))
  expect_identical(m_hs_hs, msigdbr(db_species = "hs", species = "human"))
  # Basic info
  expect_s3_class(m_hs_hs, "tbl_df")
  expect_type(m_hs_hs$gene_symbol, "character")
  expect_type(m_hs_hs$ncbi_gene, "character")
  expect_type(m_hs_hs$ensembl_gene, "character")
  expect_identical(names(m_hs_hs)[1:3], c("gene_symbol", "ncbi_gene", "ensembl_gene"))
  expect_identical(names(m_hs_hs)[4:8], c("db_gene_symbol", "db_ncbi_gene", "db_ensembl_gene", "source_gene", "gs_id"))
  expect_equal(n_distinct(m_hs_hs$db_version), 1)
  expect_identical(unique(m_hs_hs$db_target_species), "HS")
  # Overall dimensions
  expect_gt(nrow(m_hs_hs), 4400000)
  expect_lt(nrow(m_hs_hs), 4900000)
  expect_equal(n_distinct(m_hs_hs$gs_collection), 9)
  expect_equal(n_distinct(m_hs_hs$gs_subcollection), 22)
  expect_gt(n_distinct(m_hs_hs$gs_id), 34000)
  expect_gt(n_distinct(m_hs_hs$gene_symbol), 40000)
  expect_gt(n_distinct(m_hs_hs$ncbi_gene), 40000)
  expect_gt(n_distinct(m_hs_hs$ensembl_gene), 40000)
  # Gene set sizes
  expect_equal(min(table(m_hs_hs$gs_id)), 5)
  expect_lt(max(table(m_hs_hs$gs_id)), 2500)
  expect_lt(quantile(table(m_hs_hs$gs_id), 0.999), 2000)
  expect_lt(quantile(table(m_hs_hs$gs_id), 0.98), 1000)
  expect_lt(quantile(table(m_hs_hs$gs_id), 0.9), 300)
  expect_gt(quantile(table(m_hs_hs$gs_id), 0.9), 200)
  expect_gt(quantile(table(m_hs_hs$gs_id), 0.5), 40)
  expect_gt(quantile(table(m_hs_hs$gs_id), 0.2), 10)
  m_hs_hs_sym <- distinct(m_hs_hs, gs_id, db_gene_symbol)
  expect_equal(min(table(m_hs_hs_sym$gs_id)), 5)
  expect_lt(max(table(m_hs_hs_sym$gs_id)), 2001)
  m_hs_hs_ens <- distinct(m_hs_hs, gs_id, db_ensembl_gene)
  expect_equal(min(table(m_hs_hs_ens$gs_id)), 5)
  expect_lt(max(table(m_hs_hs_ens$gs_id)), 2001)

  # Human database and mouse genes
  m_hs_mm <- msigdbr(species = "Mus musculus")
  expect_s3_class(m_hs_mm, "tbl_df")
  expect_type(m_hs_mm$gene_symbol, "character")
  expect_type(m_hs_mm$ncbi_gene, "character")
  expect_type(m_hs_mm$ensembl_gene, "character")
  expect_identical(m_hs_mm, msigdbr(db_species = "hs", species = "mouse"))

  # Human database and rat genes
  m_hs_rn <- msigdbr(species = "Rattus norvegicus")
  expect_s3_class(m_hs_rn, "tbl_df")
  expect_type(m_hs_rn$gene_symbol, "character")
  expect_type(m_hs_rn$ncbi_gene, "character")
  expect_type(m_hs_rn$ensembl_gene, "character")
  expect_equal(max(m_hs_rn$num_ortholog_sources), 10)
  # Column names should be identical (extra output with orthologs)
  expect_identical(names(m_hs_hs)[1:19], names(m_hs_mm)[1:19])
  expect_identical(names(m_hs_mm)[1:19], names(m_hs_rn)[1:19])
  # Ortholog conversion should not reduce the database size substantially
  expect_gt(nrow(m_hs_mm), nrow(m_hs_hs) * 0.9)
  expect_gt(nrow(m_hs_rn), nrow(m_hs_hs) * 0.9)

  # Mouse database and mouse genes
  m_mm_mm <- msigdbr(db_species = "mm", species = "Mus musculus")
  expect_s3_class(m_mm_mm, "data.frame")
  # Column names should be identical (extra output with orthologs)
  expect_identical(names(m_mm_mm)[1:19], names(m_hs_mm)[1:19])
  # Basic info
  expect_equal(n_distinct(m_mm_mm$db_version), 1)
  expect_identical(unique(m_mm_mm$db_target_species), "MM")
  # Overall dimensions
  expect_gt(nrow(m_mm_mm), 1600000)
  expect_lt(nrow(m_mm_mm), 1900000)
  expect_gt(n_distinct(m_mm_mm$gs_collection), 5)
  expect_gt(n_distinct(m_mm_mm$gs_subcollection), 10)
  expect_gt(n_distinct(m_mm_mm$gs_id), 16000)
  expect_gt(n_distinct(m_mm_mm$db_gene_symbol), 40000)
  expect_gt(n_distinct(m_mm_mm$db_ncbi_gene), 40000)
  expect_gt(n_distinct(m_mm_mm$db_ensembl_gene), 40000)
  # Gene set sizes
  expect_equal(min(table(m_mm_mm$gs_id)), 5)
  expect_lt(max(table(m_mm_mm$gs_id)), 2900)
  expect_lt(quantile(table(m_mm_mm$gs_id), 0.999), 2000)
  expect_lt(quantile(table(m_mm_mm$gs_id), 0.98), 1000)
  expect_lt(quantile(table(m_mm_mm$gs_id), 0.9), 300)
  expect_gt(quantile(table(m_mm_mm$gs_id), 0.9), 200)
  expect_gt(quantile(table(m_mm_mm$gs_id), 0.5), 20)
  expect_gt(quantile(table(m_mm_mm$gs_id), 0.1), 5)
  m_mm_mm_sym <- distinct(m_mm_mm, gs_id, db_gene_symbol)
  expect_equal(min(table(m_mm_mm_sym$gs_id)), 5)
  expect_lt(max(table(m_mm_mm_sym$gs_id)), 2001)
  m_mm_mm_ens <- distinct(m_mm_mm, gs_id, db_ensembl_gene)
  expect_equal(min(table(m_mm_mm_ens$gs_id)), 5)
  expect_lt(max(table(m_mm_mm_ens$gs_id)), 2001)
})

test_that("collections and subcollections", {
  m_rn_bp <- msigdbr(species = "Rattus norvegicus", collection = "C5", subcollection = "BP")
  expect_s3_class(m_rn_bp, "data.frame")
  expect_gt(nrow(m_rn_bp), 25)
  expect_gt(n_distinct(m_rn_bp$gene_symbol), 10)
  expect_gt(n_distinct(m_rn_bp$ncbi_gene), 10)
  expect_gt(n_distinct(m_rn_bp$ensembl_gene), 10)
  expect_equal(n_distinct(m_rn_bp$gs_collection), 1)
  expect_equal(n_distinct(m_rn_bp$gs_subcollection), 1)
  expect_gt(n_distinct(m_rn_bp$gs_id), 1)
})

test_that("msigdbr() subcollection partial match", {
  m_mm_gomf <- msigdbr(species = "mouse", collection = "C5", subcollection = "GO:MF")
  expect_s3_class(m_mm_gomf, "data.frame")
  expect_gt(nrow(m_mm_gomf), 25)
  m_mm_mf <- msigdbr(species = "mouse", collection = "C5", subcollection = "MF")
  expect_s3_class(m_mm_mf, "data.frame")
  expect_gt(nrow(m_mm_mf), 25)
  expect_equal(nrow(m_mm_gomf), nrow(m_mm_mf))
  expect_identical(m_mm_gomf, m_mm_mf)
})

test_that("wrong parameters", {
  expect_error(msigdbr(db_species = "X"))
  expect_error(msigdbr(db_species = "RN"))
  expect_error(msigdbr(species = "test"))
  expect_error(msigdbr(species = c("Homo sapiens", "Mus musculus")))
  expect_error(msigdbr(species = ""))
  expect_error(msigdbr(species = NA))
  expect_error(msigdbr(species = "Homo sapiens", collection = "X"))
  expect_error(msigdbr(species = "Homo sapiens", collection = "X", subcollection = "X"))
  expect_error(msigdbr(species = "Homo sapiens", collection = "H", subcollection = "H"))
  expect_error(msigdbr(species = "Homo sapiens", collection = c("C1", "C2")))
  expect_error(msigdbr(species = "Homo sapiens", collection = "C2", subcollection = c("CGP", "CP")))
  expect_error(msigdbr(db_species = "mm", species = "Homo sapiens"))
  expect_error(msigdbr(db_species = "mm", species = "human"))
  expect_error(msigdbr(db_species = "mm", species = "Rattus norvegicus"))
})

test_that("deprecated parameters", {
  expect_warning(msigdbr(species = "Homo sapiens", category = "H"))
  expect_warning(msigdbr(species = "Homo sapiens", subcategory = "CGP"))
  expect_no_error(msigdbr(species = "Homo sapiens", category = NULL))
  expect_no_error(msigdbr(species = "Homo sapiens", subcategory = NULL))
  expect_identical(nrow(msigdbr(species = "human")), nrow(msigdbr(species = "human", category = NULL)))
  m_hs <- msigdbr(species = "Homo sapiens", category = "H")
  expect_contains(colnames(m_hs), c("gene_symbol", "entrez_gene", "ensembl_gene", "gs_cat", "gs_subcat"))
})

#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @import tibble
#' @import tidyselect
#' @importFrom assertthat assert_that
#' @importFrom lifecycle deprecated is_present
#' @importFrom methods is
#' @importFrom rlang .data check_installed inform is_installed
## usethis namespace: end
NULL

# Create a package-level environment for caching
pkg_env <- new.env(parent = emptyenv())

#' Download, cache, and load the gene sets database
#'
#' @param target_species Species abbreviation for human or mouse databases (`"HS"` or `"MM"`).
#' @param overwrite A logical indicating whether existing cached file should be overwritten.
#' @param verbose A logical indicating whether to print progress information.
#'
#' @return A data frame of gene sets and their member genes.
#'
#' @importFrom curl curl_download new_handle
#' @importFrom tools md5sum R_user_dir
#'
#' @noRd
load_msigdb_df <- function(target_species = c("HS", "MM"), overwrite = FALSE, verbose = FALSE) {
  target_species <- toupper(target_species)
  target_species <- match.arg(target_species)

  # Define source URL based on target species
  if (target_species == "HS") {
    # file_url <- "https://zenodo.org/records/15377497/files/msigdb.2024.1.Hs.rds?download=1"
    # file_md5 <- "ff43b9132477cbdff7243cbf3574b816"
    file_url <- "https://zenodo.org/records/15800824/files/msigdb.2025.1.Hs.rds?download=1"
    file_md5 <- "d898c396b109d61ef9b20b0632f0bfa7"
  }
  if (target_species == "MM") {
    # file_url <- "https://zenodo.org/records/15377497/files/msigdb.2024.1.Mm.rds?download=1"
    # file_md5 <- "dc60894e71d8e14e5bd0022834cca77f"
    file_url <- "https://zenodo.org/records/15800824/files/msigdb.2025.1.Mm.rds?download=1"
    file_md5 <- "e3b2d3a2aa3bd77b0b22fdf185207afd"
  }

  # Create a directory to hold the data
  cache_dir <- tools::R_user_dir(package = "msigdbr", which = "cache")
  if (!dir.exists(cache_dir)) {
    if (verbose) {
      message("Creating directory to hold data at: ", cache_dir)
    }
    dir.create(cache_dir, showWarnings = FALSE, recursive = TRUE)
  }

  # Download the file if it is not already cached
  file_name <- basename(file_url)
  file_name <- sub("\\?.*$", "", file_name)
  file_path <- file.path(cache_dir, file_name)
  if (!file.exists(file_path) || overwrite) {
    if (verbose) {
      message("Downloading data to: ", file_path)
    }
    curl::curl_download(
      url = file_url,
      destfile = file_path,
      quiet = verbose,
      handle = curl::new_handle(timeout = 300)
    )

    # Verify download
    if (tools::md5sum(file_path) != file_md5) {
      file.remove(file_path)
      stop("Downloaded file does not match the expected checksum.")
    }
  }

  if (!file.exists(file_path)) {
    stop("Data file not found: ", file_path)
  }

  # Load data if already in memory cache
  if (exists(file_name, envir = pkg_env, inherits = FALSE)) {
    if (verbose) {
      message("Loading data from cache.")
    }
    return(pkg_env[[file_name]])
  }

  # Read RDS file and cache the data frame
  if (verbose) {
    message("Loading data from: ", file_path)
  }
  mdb <- readRDS(file_path)
  pkg_env[[file_name]] <- mdb
  return(mdb)
}

#' List the collections available in the msigdbr package
#'
#' @return A data frame of the available collections.
#'
#' @param db_species Species abbreviation for the human or mouse databases (`"HS"` or `"MM"`).
#'
#' @importFrom dplyr arrange count distinct
#'
#' @export
#'
#' @examplesIf (identical(Sys.getenv("NOT_CRAN"), "true") || identical(Sys.getenv("IN_PKGDOWN"), "true"))
#' msigdbr_collections()
msigdbr_collections <- function(db_species = "HS") {
  # Get the full table of gene sets and their member genes
  mc <- load_msigdb_df(target_species = db_species)
  mc <- tibble::as_tibble(mc)

  # Keep only gene set information (ignore genes)
  mc <- dplyr::distinct(
    mc,
    .data$gs_collection,
    .data$gs_subcollection,
    .data$gs_collection_name,
    .data$gs_id
  )

  # Count the number of gene sets per collection
  mc <- dplyr::count(
    mc,
    .data$gs_collection,
    .data$gs_subcollection,
    .data$gs_collection_name,
    name = "num_genesets"
  )

  # Sort
  mc <- dplyr::arrange(mc, .data$gs_collection, .data$gs_subcollection)

  return(mc)
}

# Skip on CRAN due to long run-time and use of web resources
skip_on_cran()

test_that("msigdbr_collections()", {
  chs <- msigdbr_collections(db_species = "Hs")
  expect_identical(chs, msigdbr_collections())
  expect_s3_class(chs, "tbl_df")
  expect_gt(nrow(chs), 10)
  expect_lt(nrow(chs), 30)
  expect_match(chs$gs_collection, "H", fixed = TRUE, all = FALSE)
  expect_match(chs$gs_collection, "C2", fixed = TRUE, all = FALSE)
  expect_match(chs$gs_collection, "C7", fixed = TRUE, all = FALSE)
  expect_match(chs$gs_collection, "C8", fixed = TRUE, all = FALSE)
  cmm <- msigdbr_collections(db_species = "Mm")
  expect_s3_class(cmm, "tbl_df")
  expect_gt(nrow(cmm), 10)
  expect_lt(nrow(cmm), 30)
  expect_match(cmm$gs_collection, "MH", fixed = TRUE, all = FALSE)
  expect_match(cmm$gs_collection, "M8", fixed = TRUE, all = FALSE)
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/msigdbr.R
\name{msigdbr}
\alias{msigdbr}
\title{Retrieve the gene sets data frame}
\usage{
msigdbr(
  db_species = "HS",
  species = "human",
  collection = NULL,
  subcollection = NULL,
  category = deprecated(),
  subcategory = deprecated()
)
}
\arguments{
\item{db_species}{Species abbreviation for the human or mouse databases (\code{"HS"} or \code{"MM"}).}

\item{species}{Species name for output genes, such as \code{"Homo sapiens"} or \code{"Mus musculus"}. Both scientific and common names are acceptable. Use \code{msigdbr_species()} to see the available options.}

\item{collection}{Collection abbreviation, such as \code{"H"} or \code{"C1"}. Use \code{msigdbr_collections()} to see the available options.}

\item{subcollection}{Sub-collection abbreviation, such as \code{"CGP"} or \code{"BP"}. Use \code{msigdbr_collections()} for the available options.}

\item{category}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} use the \code{collection} argument}

\item{subcategory}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} use the \code{subcollection} argument}
}
\value{
A tibble (a data frame with class \code{\link[tibble:tbl_df-class]{tibble::tbl_df}}) of gene sets with one gene per row.
}
\description{
Retrieve a data frame of gene sets and their member genes.
The original human genes can be converted into their corresponding counterparts in various model organisms, including mouse, rat, pig, zebrafish, fly, and yeast.
The output includes gene symbols along with NCBI and Ensembl IDs.
}
\details{
Historically, the MSigDB resource has been tailored to the analysis of human-specific datasets, with gene sets exclusively aligned to the human genome.
Starting with release 2022.1, MSigDB incorporated a database of mouse-native gene sets and was split into human and mouse divisions ("Hs" and "Mm").
Each one is provided in the approved gene symbols of its respective species.

Mouse MSigDB includes gene sets curated from mouse-centric datasets and specified in native mouse gene identifiers, eliminating the need for ortholog mapping.
}
\examples{
\dontshow{if ((identical(Sys.getenv("NOT_CRAN"), "true") || identical(Sys.getenv("IN_PKGDOWN"), "true"))) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
# Get all human gene sets
gs <- msigdbr()
head(gs)

# Get all mouse gene sets
gs <- msigdbr(db_species = "MM", species = "Mus musculus")
head(gs)

# Get CGP (chemical and genetic perturbations) gene sets with genes mapped to rat orthologs
gs <- msigdbr(species = "Rattus norvegicus", collection = "C2", subcollection = "CGP")
head(gs)
\dontshow{\}) # examplesIf}
}
\references{
\url{https://www.gsea-msigdb.org/gsea/msigdb/index.jsp}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/msigdbr-package.R
\docType{package}
\name{msigdbr-package}
\alias{msigdbr-package}
\title{msigdbr: MSigDB Gene Sets for Multiple Organisms in a Tidy Data Format}
\description{
Provides the 'Molecular Signatures Database' (MSigDB) gene sets typically used with the 'Gene Set Enrichment Analysis' (GSEA) software (Subramanian et al. 2005 \doi{10.1073/pnas.0506580102}, Liberzon et al. 2015 \doi{10.1016/j.cels.2015.12.004}, Castanza et al. 2023 \doi{10.1038/s41592-023-02014-7}) as an R data frame. The package includes the human genes as listed in MSigDB as well as the corresponding symbols and IDs for frequently studied model organisms such as mouse, rat, pig, fly, and yeast.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://igordot.github.io/msigdbr/}
  \item Report bugs at \url{https://github.com/igordot/msigdbr/issues}
}

}
\author{
\strong{Maintainer}: Igor Dolgalev \email{igor.dolgalev@nyumc.org} (\href{https://orcid.org/0000-0003-4451-126X}{ORCID})

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/msigdbr-collections.R
\name{msigdbr_collections}
\alias{msigdbr_collections}
\title{List the collections available in the msigdbr package}
\usage{
msigdbr_collections(db_species = "HS")
}
\arguments{
\item{db_species}{Species abbreviation for the human or mouse databases (\code{"HS"} or \code{"MM"}).}
}
\value{
A data frame of the available collections.
}
\description{
List the collections available in the msigdbr package
}
\examples{
\dontshow{if ((identical(Sys.getenv("NOT_CRAN"), "true") || identical(Sys.getenv("IN_PKGDOWN"), "true"))) (if (getRversion() >= "3.4") withAutoprint else force)(\{ # examplesIf}
msigdbr_collections()
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/msigdbr-species.R
\name{msigdbr_species}
\alias{msigdbr_species}
\title{List the species available in the msigdbr package}
\usage{
msigdbr_species()
}
\value{
A data frame of the available species.
}
\description{
List the species available in the msigdbr package
}
\examples{
msigdbr_species()
}
